<template>
  <div>
    <h2 id="page-heading" data-cy="IngestaHeading">
      <span v-text="$t('gatewayApp.manillaIngesta.home.title')" id="ingesta-heading">Ingestas</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.manillaIngesta.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'IngestaCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-ingesta"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.manillaIngesta.home.createLabel')"> Create a new Ingesta </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && ingestas && ingestas.length === 0">
      <span v-text="$t('gatewayApp.manillaIngesta.home.notFound')">No ingestas found</span>
    </div>
    <div class="table-responsive" v-if="ingestas && ingestas.length > 0">
      <table class="table table-striped" aria-describedby="ingestas">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('tipo')">
              <span v-text="$t('gatewayApp.manillaIngesta.tipo')">Tipo</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'tipo'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('consumoCalorias')">
              <span v-text="$t('gatewayApp.manillaIngesta.consumoCalorias')">Consumo Calorias</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'consumoCalorias'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaRegistro')">
              <span v-text="$t('gatewayApp.manillaIngesta.fechaRegistro')">Fecha Registro</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaRegistro'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('user.login')">
              <span v-text="$t('gatewayApp.manillaIngesta.user')">User</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'user.login'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="ingesta in ingestas" :key="ingesta.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'IngestaView', params: { ingestaId: ingesta.id } }">{{ ingesta.id }}</router-link>
            </td>
            <td>{{ ingesta.tipo }}</td>
            <td>{{ ingesta.consumoCalorias }}</td>
            <td>{{ ingesta.fechaRegistro ? $d(Date.parse(ingesta.fechaRegistro), 'short') : '' }}</td>
            <td>
              {{ ingesta.user ? ingesta.user.login : '' }}
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'IngestaView', params: { ingestaId: ingesta.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'IngestaEdit', params: { ingestaId: ingesta.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(ingesta)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="gatewayApp.manillaIngesta.delete.question" data-cy="ingestaDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-ingesta-heading" v-text="$t('gatewayApp.manillaIngesta.delete.question', { id: removeId })">
          Are you sure you want to delete this Ingesta?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-ingesta"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeIngesta()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./ingesta.component.ts"></script>
